library EKlav;
{
	========================================================================

	Modulo:	EKlav	  	Tasko:	Klaveventa traktilo kaj enhokigo

    ========================================================================

    Funkcio:	Tiu chi modulo provizas chiujn meqanismojn necesajn por
    			enkonduki propran traktilon en la fluon de Vindozaj klav-
                eventoj. Por tio servas la API-funcio SetHook(). Poste
                Vindozo vokas la provizitajn funkciojn - KeyProc() au
                DKeyProc().

                Chiun fojon, ke la surfaca stirmodulo lanchas tiun DLL-on,
                objekto de la klaso TEKeys kreighas, kiu ricevas freshan
                objekton de la klaso TEKData. TEKeys provizas klaveventan
                traktilon por KeyProc() kaj TEKData provizas parametrojn el
                la registrejo por stiri ghin.

    ========================================================================
    Dato		Autoro			Modifo
    ========================================================================
    99.01.01	Jury Finkel		Prapretigo
    99.08.01	Simon Payne		Reordigo kaj enkonduko de rekordo TEspData
    99.10.14	Simon Payne		Objektemigita rilate la legadon de la
    							registrejo. Nun aparta modulo UEKData
    ========================================================================
}

uses
  Windows,
  SysUtils,
  UEKeys in 'UEKeys.pas',
  UKeys in 'UKeys.pas',
  ULib in 'ULib.pas',
  URegData in 'URegData.pas';

var
    mtHook: THandle;
    moKeys: TEKeys;

function KeyProc (piCode: Integer; plKey, plParam: Longint): Longint; stdcall;
begin
    Result:=0;
    if moKeys<>nil then
        Result:=ord(moKeys.eKeyProc(piCode, plKey, plParam, true));
    if Result=0 then
        Result:=CallNextHookEx (mtHook, piCode, plKey, plParam);
end;

function DKeyProc (piCode: Integer; plKey, plParam: Longint): Longint; stdcall;
begin
    Result:=0;
    if moKeys<>nil then
        Result:=ord(moKeys.eKeyProc(piCode, plKey, plParam, false));
      if Result=0 then
        Result:=CallNextHookEx (mtHook, piCode, plKey, plParam);
end;

procedure RemoveHook; stdcall;
begin
    if mtHook<>0 then
        if UnHookWindowsHookEx(mtHook)= False then
            exit;
    mtHook:=0;
end;

{Kaptu klavareventojn lau rekta metodo}

procedure SetHook; stdcall;
begin
    if mtHook<>0 then
        RemoveHook;
    mtHook:=SetWindowsHookEx(WH_KEYBOARD, KeyProc, hInstance, 0);
end;

{Kaptu klavareventojn lau senpasha metodo}

procedure SetHookD; stdcall;
begin
    if mtHook<>0 then
        RemoveHook;
    mtHook:=SetWindowsHookEx(WH_KEYBOARD, DKeyProc, hInstance, 0);
end;

exports
    SetHook  index 1,
    SetHookD index 2,
    SetHook  index 3,
    RemoveHook index 4;

var SaveExit: Pointer;

procedure LibExit;
begin
  RemoveHook;
  ExitProc := SaveExit;
end;

begin
    mtHook:=0;
    moKeys:=TEKeys.Create(TRegData.Create);
    SaveExit := ExitProc;
    ExitProc := @LibExit;
end.

