unit Groups;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Registry, ShellAPI, ShlObj, ActiveX;

const IID_IPersistFile: TGUID = (
  D1:$0000010B;D2:$0000;D3:$0000;D4:($C0,$00,$00,$00,$00,$00,$00,$46));

procedure MakeDesktopIcon (Path: String; Arg: String);
procedure DelDesktopIcon;
procedure ReadGroups (Strings: TStrings);
function GetSpecialFolderLocation (nFolder: Integer): String;

implementation

procedure ReadGroups (Strings: TStrings);
var
  ARegistry: TRegistry;
  Programs: String;
  SearchRec: TSearchRec;
  FindResult: Integer;
begin
  Strings.Clear;
  // Trovu dosierujon
  ARegistry := TRegistry.Create;
  with ARegistry do
  begin
    RootKey := HKEY_CURRENT_USER;
    if OpenKey('\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders', False) then
    begin
      Programs := ReadString('Programs');
      CloseKey;
    end
    else
      Programs := '';
    Free;
  end;
  if (Length(Programs) > 0) and (Programs[Length(Programs)] <> '\') then
    Programs := Programs + '\';
  // Legu enhavon de la dosierujo
  FindResult := FindFirst(Programs + '*.*', faDirectory, SearchRec);
  while FindResult = 0 do
  begin
    with SearchRec do                                                 
      if (Name <> '.') and (Name <> '..') and (Attr and faDirectory <> 0) then            
        Strings.Add(Name);                                                   
    FindResult := FindNext(SearchRec);
  end;
  FindClose(SearchRec);
end;

function GetSpecialFolderLocation (nFolder: Integer): String;
var
  ppidl: PItemIDList;
  Malloc: IMalloc;
  szPath: array[0..MAX_PATH - 1] of Char;
begin
  SHGetSpecialFolderLocation(0, nFolder, ppidl);
  SHGetMalloc(Malloc);
  SHGetPathFromIDList(ppidl, szPath);
  Malloc.Free(ppidl);
  Malloc := nil;
  Result := String(szPath);
end;

procedure MakeDesktopIcon (Path: String; Arg: String);
var
  Desktop: String;
  ShellLink: IShellLink;
  hRes: HRESULT;
  PersistFile: IPersistFile;
begin
  // Trovu dosierujon
  Desktop := GetSpecialFolderLocation(CSIDL_DESKTOPDIRECTORY);
  if (Length(Desktop) > 0) and (Desktop[Length(Desktop)] <> '\') then
    Desktop := Desktop + '\';
  CoInitialize(nil);
  hRes := CoCreateInstance(CLSID_ShellLink, nil, CLSCTX_INPROC_SERVER,
    IID_IShellLinkA, ShellLink);
  if SUCCEEDED(hRes) then
  begin
    ShellLink.SetPath(PChar(Path));
    ShellLink.SetArguments(PChar(Arg));
    ShellLink.SetDescription('Ek!');
    hRes := ShellLink.QueryInterface(IID_IPersistFile, PersistFile);
    if SUCCEEDED(hRes) then
    begin
      PersistFile.Save(PWideChar(WideString(Desktop + 'Ek!.lnk')), True);
      PersistFile := nil;
    end;
    ShellLink := nil;
  end;
  CoUninitialize;
end;

procedure DelDesktopIcon;
 var Desktop: String;
begin
  // Trovu dosierujon
  Desktop := GetSpecialFolderLocation(CSIDL_DESKTOPDIRECTORY);
  if (Length(Desktop) > 0) and (Desktop[Length(Desktop)] <> '\') then
    Desktop := Desktop + '\';
  DeleteFile(DeskTop+'Ek!.lnk');
end;

end.


