unit Esperanto;
{*********
 Esperantigitaj unikodaj anstatauajhoj
 por ordinaraj komponantoj de Delfo
*********}
interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Registry, ShellAPI, Graphics;

var

{Por malpermesi Unikodon, skribu en komenco de chefa programdosiero:
   UseUnicode:=False;
 kaj tiam anstatau chapelitaj literoj estos uzata h-skribo.
}
  UseUnicode: Boolean=True;     {Chu ni rajtas uzi Unikodon?}

{Por shanghi tiparon de shpruc-helpilo, skribu en komenco de chefa
 programdosiero, ekzemple, jenon:
   HintFontName:='Tahoma';
}
  HintFontName: String='Arial'; {la plej disvastigita senserifa unikoda tiparo}

type
  {Klaso de unikoda esperanta marko}
  TeoLabel = class(TLabel)
   private
    FOnMouseEnter: TNotifyEvent;
    FOnMouseLeave: TNotifyEvent;
   protected
    procedure DoDrawText (var Rect: TRect; Flags: Longint); override;
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
   published
    property OnMouseEnter: TNotifyEvent read FOnMouseEnter write FOnMouseEnter;
    property OnMouseLeave: TNotifyEvent read FOnMouseLeave write FOnMouseLeave;
  end;

  {Klaso, montranta shpruc-helpilon}
  { Por aktivigi ghin, skribu en komenco de chefa programdosiero:
       HintWindowClass:=TeoHintWindow;
  }
  TeoHintWindow = class(THintWindow)
   protected
    procedure Paint; override;
   public
    function CalcHintRect(MaxWidth: Integer; const AHint: string; AData: Pointer): TRect; override;
    constructor Create(AOwner: TComponent); override;
  end;

  {Klaso de unikoda esperanta butono}
  TeoButton = class(TButton)
   private
    FCanvas : TCanvas;
    FCaption: TCaption;
    FPressed, FCurrent: Boolean; {internaj statoj de butono}
    procedure SetText(const Value: TCaption);
   public
    procedure PaintWindow(DC: HDC); override;
    procedure Paint; virtual;
    procedure Click; override;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    {Kaptiloj de vindozaj eventoj:}
    procedure WMKeyDown(var Message: TWMKeyDown); message WM_KEYDOWN;
    procedure WMLButtonDown(var Message: TWMLButtonDown); message WM_LButtonDown;
    procedure WMLButtonUp(var Message: TWMLButtonDown); message WM_LButtonUp;
    procedure WMNCLButtonDown(var Message: TWMNCLButtonDown); message WM_NCLButtonDown;
    procedure WMLButtonDblClk(var Message: TWMLButtonDblClk); message WM_LBUTTONDBLCLK;
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    procedure CMTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
   published
    property Caption: TCaption read FCaption write SetText {stored IsCaptionStored};
  end;

  {Klaso de unikoda esperanta listo}
  TeoListBox = class(TListBox)
   protected
    procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState); override;
    procedure CreateParams(var Params: TCreateParams); override;
  end;

  {Klaso de unikoda esperanta markujo}
  TeoCheckBox = class(TCheckBox)
   private
    FCanvas : TCanvas;
    FCaption: TCaption;
    FOnMouseEnter: TNotifyEvent;
    FOnMouseLeave: TNotifyEvent;
    procedure SetText(const Value: TCaption);
   protected
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
   public
    procedure PaintWindow(DC: HDC); override;
    procedure Paint; virtual;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
   published
    property Caption: TCaption read FCaption write SetText {stored IsCaptionStored};
    property OnMouseEnter: TNotifyEvent read FOnMouseEnter write FOnMouseEnter;
    property OnMouseLeave: TNotifyEvent read FOnMouseLeave write FOnMouseLeave;
  end;

  {Klaso de unikoda esperanta radiobutono}
  TeoRadioButton = class(TRadioButton)
   private
    FCanvas : TCanvas;
    FCaption: TCaption;
    FOnMouseEnter: TNotifyEvent;
    FOnMouseLeave: TNotifyEvent;
    procedure SetText(const Value: TCaption);
   protected
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
   public
    procedure PaintWindow(DC: HDC); override;
    procedure Paint; virtual;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
   published
    property Caption: TCaption read FCaption write SetText {stored IsCaptionStored};
    property OnMouseEnter: TNotifyEvent read FOnMouseEnter write FOnMouseEnter;
    property OnMouseLeave: TNotifyEvent read FOnMouseLeave write FOnMouseLeave;
  end;

procedure Register;

{Funkcioj de konvertado:}
function XtoU (S: String): WideString; {x-skribo -> Unikodo}
function UtoX (U: WideString): String; {Unikodo  -> x-skribo}
function UtoH (U: WideString): String; {Unikodo  -> h-skribo}
function SenChapel (S: String): String; {Senchapeligo}

implementation

procedure Register;
begin
  RegisterComponents('Esperanto', [TeoLabel]);
  RegisterComponents('Esperanto', [TeoButton]);
  RegisterComponents('Esperanto', [TeoCheckBox]);
  RegisterComponents('Esperanto', [TeoRadioButton]);
  RegisterComponents('Esperanto', [TeoListBox]);
end; {Register}

{Konverto el cx-skribo al Unikodo}
function XtoU (S: String): WideString;
 var W: WChar;
     i: Integer;
begin
  result:='';
  i:=1;
  while i<=length(S) do
  begin
        W:=WChar(S[i]);
        if      Copy(S,i,2)='Cx' then W:=WChar(264)
        else if Copy(S,i,2)='cx' then W:=WChar(265)
        else if Copy(S,i,2)='Gx' then W:=WChar(284)
        else if Copy(S,i,2)='gx' then W:=WChar(285)
        else if Copy(S,i,2)='Hx' then W:=WChar(292)
        else if Copy(S,i,2)='hx' then W:=WChar(293)
        else if Copy(S,i,2)='Jx' then W:=WChar(308)
        else if Copy(S,i,2)='jx' then W:=WChar(309)
        else if Copy(S,i,2)='Sx' then W:=WChar(348)
        else if Copy(S,i,2)='sx' then W:=WChar(349)
        else if Copy(S,i,2)='Ux' then W:=WChar(364)
        else if Copy(S,i,2)='ux' then W:=WChar(365)
        else if Copy(S,i,2)='Xx' then W:=WChar('X')
        else if Copy(S,i,2)='xx' then W:=WChar('x')
        else Dec(i);
        result:=result+W;
        Inc(i,2);
  end;
end; {XtoU}

{Konverto el Unikodo al x-skribo}
function UtoX (U: WideString): String;
 var W: WChar;
     i: Integer;
begin
  result:='';
  for i:=1 to length(U) do
  begin
        W:=WChar(U[i]);
        if      W=WChar(264) then result:=result+'Cx'
        else if W=WChar(265) then result:=result+'cx'
        else if W=WChar(284) then result:=result+'Gx'
        else if W=WChar(285) then result:=result+'gx'
        else if W=WChar(292) then result:=result+'Hx'
        else if W=WChar(293) then result:=result+'hx'
        else if W=WChar(308) then result:=result+'Jx'
        else if W=WChar(309) then result:=result+'jx'
        else if W=WChar(348) then result:=result+'Sx'
        else if W=WChar(349) then result:=result+'sx'
        else if W=WChar(364) then result:=result+'Ux'
        else if W=WChar(365) then result:=result+'ux'
        else if W=WChar('X') then result:=result+'Xx'
        else if W=WChar('x') then result:=result+'xx'
        else result:=result+W;
  end;
end; {UtoX}

{Konverto el Unikodo al h-skribo}
function UtoH (U: WideString): String;
 var W: WChar;
     i: Integer;
begin
  result:='';
  for i:=1 to length(U) do
  begin
        W:=WChar(U[i]);
        if      W=WChar(264) then result:=result+'Ch'
        else if W=WChar(265) then result:=result+'ch'
        else if W=WChar(284) then result:=result+'Gh'
        else if W=WChar(285) then result:=result+'gh'
        else if W=WChar(292) then result:=result+'Hh'
        else if W=WChar(293) then result:=result+'hh'
        else if W=WChar(308) then result:=result+'Jh'
        else if W=WChar(309) then result:=result+'jh'
        else if W=WChar(348) then result:=result+'Sh'
        else if W=WChar(349) then result:=result+'sh'
        else if W=WChar(364) then result:=result+'U'
        else if W=WChar(365) then result:=result+'u'
        else result:=result+W;
  end;
end; {UtoH}

{Senchapeligo}
function SenChapel (S: String): String;
 var i: Integer;
     C: Char;
begin
    result:='';
    i:=1;
    while i<=Length(S) do
    begin
        C:=S[i];
        if      Copy(S,i,2)='Cx' then
        else if Copy(S,i,2)='cx' then
        else if Copy(S,i,2)='Gx' then
        else if Copy(S,i,2)='gx' then
        else if Copy(S,i,2)='Hx' then
        else if Copy(S,i,2)='hx' then
        else if Copy(S,i,2)='Jx' then
        else if Copy(S,i,2)='jx' then
        else if Copy(S,i,2)='Sx' then
        else if Copy(S,i,2)='sx' then
        else if Copy(S,i,2)='Ux' then
        else if Copy(S,i,2)='ux' then
        else if Copy(S,i,2)='Xx' then
        else if Copy(S,i,2)='xx' then
        else Dec(i);
        result:=result+C;
        Inc(i,2);
    end;
end; {SenChapel}

{Unikoda eligo kaj mezurado de teksto}
procedure uOut (Show: Boolean; Handle: HDC;
        Left,Top: LongInt; U: WideString; var Delta: TagSize);
 var S: String;
begin
    if UseUnicode then  {chio en Unikodo}
    begin
        if Show then TextOutW(Handle,Left,Top,PWChar(U),Length(U));
        GetTextExtentPoint32W(Handle,PWChar(U),Length(U),Delta);
    end
    else begin          {chio en h-skribo}
        S:=UtoH(U);
        if Show then TextOut(Handle,Left,Top,PChar(S),Length(S));
        GetTextExtentPoint32(Handle,PChar(S),Length(S),Delta);
    end;
end; {uOut}


{--- TeoLabel ---}

{Pentrado de teksto de marko}
procedure TeoLabel.DoDrawText (var Rect: TRect; Flags: Longint);
 var Text: string;
     U: WideString;
     Max: TagSize;
 {Propre pentrado de teksto}
 procedure TOut;
 var i: Integer;
     sub: Boolean;
     Delta,CharPos: TagSize;
     OldStyle: TFontStyles;
 begin
    CharPos.cx:=0; CharPos.cy:=0;
    Delta.cy:=0; Delta.cy:=0;
    sub:=False;
    OldStyle:=Canvas.Font.Style;
    for i:=1 to Length(U) do
    begin
        if U[i]=WChar('&') then         {sekva litero estos akcelilo}
            sub:=True
        else if U[i]=WChar(^M) then
        else if U[i]=WChar(^J) then     {nova linio}
        begin
            CharPos.cy:=CharPos.cy+Delta.cy;
            Max.cy:=Max.cy+Delta.cy;
            CharPos.cx:=0;
        end
        else begin
            if sub and ShowAccelChar then
                Canvas.Font.Style:=Canvas.Font.Style + [fsUnderline]
            else
                Canvas.Font.Style:=OldStyle;
            uOut(Canvas.LockCount<>0,Canvas.Handle,
                Rect.Left+CharPos.cx,Rect.Top+CharPos.cy,
                Copy(U,i,1),Delta);
            CharPos.cx:=CharPos.cx+Delta.cx;
            if CharPos.cx>Max.cx then Max.cx:=CharPos.cx;
            sub:=False;
        end;
    end;
    Max.cy:=Max.cy+Delta.cy;
 end; {TOut}
begin
  Text:=GetLabelText;
  Max.cx:=0; Max.cy:=0;
  U:=XtoU(Text);
  {if (Flags and DT_CALCRECT <> 0) and ((Text = '') or ShowAccelChar and
     (Text[1] = '&') and (Text[2] = #0)) then Text:=Text + ' ';
   Flags:=DrawTextBiDiModeFlags(Flags);}
  Canvas.Font:=Font;
  if Enabled then
    Tout
  else begin
    {pentru malpermesitan butonon kiel enpremitan en la kanvason}
    OffsetRect(Rect, 1, 1);
    Canvas.Font.Color:=clBtnHighlight;
    TOut;
    OffsetRect(Rect, -1, -1);
    Canvas.Font.Color:=clBtnShadow;
    TOut;
  end;
  Rect.Right :=Rect.Left+ Max.cx; {por automata kalkulado de grandeco}
  Rect.Bottom:=Rect.Top + Max.cy;
end; {TeoLabel.DoDrawText}

{Kaptu eventon, kiam musmontrilo eniras sur la markon}
procedure TeoLabel.CMMouseEnter (var Message: TMessage);
begin
  inherited;
  if Assigned(FOnMouseEnter) then FOnMouseEnter(Self);
end; {TeoLabel.CMMouseEnter}

{Kaptu eventon, kiam musmontrilo foriras el sur la marko}
procedure TeoLabel.CMMouseLeave (var Message: TMessage);
begin
  inherited;
  if Assigned(FOnMouseLeave) then FOnMouseLeave(Self);
end; {TeoLabel.CMMouseLeave}


{--- eoPaint ---}

{Komuna proceduro por pentrado de unikodaj titoloj
de buton-similaj objektoj}
procedure eoPaint (var Canvas: TCanvas; Caption: String;
    ClientRect: TRect; Clear: Boolean; Pressed: Boolean; RX: LongInt);
 var Rect: TRect;
     Delta: TagSize;
     U: WideString;
     n: Integer;
     OldStyle: TFontStyles;
begin
    {Konvertado de teksto al Unikodo}
    U:=XtoU(Caption);
    n:=Pos('&',U);              {signo de akcelilo}
    if n>0 then Delete(u,n,1);  {memorigu ghian lokon kaj forigu ghin}

    if Clear then
    begin                       {Purigo de loko}
        Rect:=ClientRect;
        Inc(Rect.Left,5); Dec(Rect.Right,5);
        Inc(Rect.Top,5);  Dec(Rect.Bottom,5);
        Canvas.FillRect(Rect);
    end;

    {Kalkulo de pozicio}
    Rect:=ClientRect;
    uOut(False,Canvas.Handle,Rect.Left,Rect.Top,U,Delta);
    if RX>0 then
        Rect.Left:=Rect.Left+RX
    else {centrigu horizontale}
      if Delta.cx<Rect.Right-Rect.Left-1 then
        Rect.Left:=Rect.Left+((Rect.Right-Rect.Left)-Delta.cx) div 2;
    {centrigu vertikale}
    if Delta.cy<Rect.Bottom-Rect.Top-1 then
        Rect.Top:=Rect.Top+((Rect.Bottom-Rect.Top)-Delta.cy) div 2;
    {deshovu, se la butono estas premita}
    if Pressed then
    begin
        Inc(Rect.Left);
        Inc(Rect.Top);
    end;

    {Propre pentrado}
    Delta.cx:=0; Delta.cy:=0;
    if n>0 then
    begin
        uOut(True,Canvas.Handle,Rect.Left,Rect.Top,Copy(U,1,n-1),Delta);
        OldStyle:=Canvas.Font.Style;
        Canvas.Font.Style:=Canvas.Font.Style + [fsUnderline];
        Rect.Left:=Rect.Left+Delta.cx;
        uOut(True,Canvas.Handle,Rect.Left,Rect.Top,Copy(U,n,1),Delta);
        Canvas.Font.Style:=OldStyle;
    end;
    Rect.Left:=Rect.Left+Delta.cx;
    uOut(True,Canvas.Handle,Rect.Left,Rect.Top,Copy(U,n+1,Length(U)-n),Delta);
end; {eoPaint}

{--- TeoButton ---}

constructor TeoButton.Create (AOwner: TComponent);
begin
  inherited Create(AOwner);
  FCanvas:=TControlCanvas.Create; {ni pentros sur tiu chi kanvaso}
  TControlCanvas(FCanvas).Control:=Self;
  FPressed:=False; FCurrent:=False;
  FCaption:='';
  ControlState:=ControlState + [csCustomPaint];
end; {TeoButton.Create}

destructor TeoButton.Destroy;
begin
  FCanvas.Free;
  inherited Destroy;
end; {TeoButton.Destroy}

{Skribado de FCaption}
procedure TeoButton.SetText (const Value: TCaption);
begin
    FCaption:=Value;
    {por Vindozo sciu pri akceliloj kaj ghuste pentru kadreton}
    inherited Caption:=SenChapel(Value);
    Paint;
end; {TeoButton.SetText}

{Pentrado de butona fenestro}
procedure TeoButton.PaintWindow (DC: HDC);
begin
  FCanvas.Lock;
  try
    FCanvas.Handle:=DC;
    try
      inherited PaintWindow(DC);
      TControlCanvas(FCanvas).UpdateTextFlags;
      Paint;    {nepre necesas repentri, alie Vindozo vishos nian tekston}
    finally
      FCanvas.Handle:=0;
    end;
  finally
    FCanvas.Unlock;
  end;
end; {TeoButton.PaintWindow}

{Pentrado de butono}
procedure TeoButton.Paint;
begin
    if Parent=nil then exit;    {alie okazos krasho dum dizajn-tempo}
    FCanvas.Font:=Font;
    FCanvas.Brush.Color:=Color;
    eoPaint(FCanvas,FCaption,GetClientRect,True,FPressed,0);
end; {TeoButton.Paint}

{Kaptiloj de vindozaj eventoj}

{Premita klavo}
procedure TeoButton.WMKeyDown (var Message: TWMKeyDown);
begin
    inherited;
    if (Chr(Message.CharCode)=' ') then FPressed:=True;
    Paint;
end; {TeoButton.WMKeyDown}

{Premita maldekstra musbutono}
procedure TeoButton.WMLButtonDown (var Message: TWMLButtonDown);
begin
    inherited;
    FPressed:=True; FCurrent:=True;
    Paint;
end; {TeoButton.WMLButtonDown}

{Malpremita maldekstra musbutono}
procedure TeoButton.WMLButtonUp (var Message: TWMLButtonDown);
begin
    inherited;
    FPressed:=False; FCurrent:=False;
    Paint;
end; {TeoButton.WMLButtonUp}

{Maldekstra musbutono premita aliloke}
procedure TeoButton.WMNCLButtonDown (var Message: TWMNCLButtonDown);
begin
    inherited;
    FPressed:=False; FCurrent:=False;
    Paint;
end; {TeoButton.WMNCLButtonDown}

{Duobla musklako}
procedure TeoButton.WMLButtonDblClk (var Message: TWMLButtonDblClk);
begin
    inherited;
    FPressed:=True; FCurrent:=True;
    Paint;
end; {TeoButton.WMLButtonDblClk}

{Klako de la butono}
procedure TeoButton.Click;
begin
    inherited;
    FPressed:=False; FCurrent:=False;
    Paint;
end; {TeoButton.Click}

{Muso suriras la butonon}
procedure TeoButton.CMMouseEnter (var Message: TMessage);
begin
    inherited;
    FPressed:=True;
    if FCurrent then Paint;
end; {TeoButton.CMMouseEnter}

{Muso eliras de la butono}
procedure TeoButton.CMMouseLeave (var Message: TMessage);
begin
    inherited;
    FPressed:=False;
    if FCurrent then Paint;
end; {TeoButton.CMMouseLeave}

{Teksto de la butono estas shanghita}
procedure TeoButton.CMTextChanged (var Message: TMessage);
begin
    inherited;
    Paint;
end; {TeoButton.CMTextChanged}


{--- TeoHintWindow ---}

constructor TeoHintWindow.Create (AOwner: TComponent);
begin
    inherited;
    Canvas.Font.Name:=HintFontName;
end; {TeoHintWindow.Create}

{Kalkulado de grandeco de shpruc-helpa fenestro}
function TeoHintWindow.CalcHintRect (MaxWidth: Integer;
        const AHint: string; AData: Pointer): TRect;
 var Delta: TagSize;
begin
  Result:=Rect(0, 0, MaxWidth, 0);
  uOut(False,Canvas.Handle,0,0,XtoU(AHint),Delta);
  Result.Right:=Delta.cx+6;
  Result.Bottom:=Delta.cy+2;
end; {TeoHintWindow.CalcHintRect}

{Pentrado de shpruc-helpilo}
procedure TeoHintWindow.Paint;
 var R: TRect;
     Delta: TagSize;
begin
  R:=ClientRect;
  Inc(R.Left, 2);
  Inc(R.Top, 2);
  Canvas.Font.Color:=clInfoText;
  uOut(True,Canvas.Handle,R.Left,R.Top,XtoU(Caption),Delta);
end; {TeoHintWindow.Paint}


{--- TeoListBox ---}

procedure TeoListBox.CreateParams(var Params: TCreateParams);
begin
    if Style=lbStandard then Style:=lbOwnerDrawFixed;
    inherited;
end; {TeoListBox.CreateParams}

{Pentrado de linio de la listo}
procedure TeoListBox.DrawItem (Index: Integer; Rect: TRect; State: TOwnerDrawState);
 var U: WideString;
     Delta: TagSize;
begin
    if Assigned(OnDrawItem) then
        OnDrawItem(Self, Index, Rect, State)
    else begin
        Canvas.FillRect(Rect);
        U:=XtoU(Items[Index]);
        uOut(True,Canvas.Handle,Rect.Left,Rect.Top,U,Delta);
    end;
end; {TeoListBox.DrawItem}


{--- TeoCheckBox ---}

constructor TeoCheckBox.Create (AOwner: TComponent);
begin
  inherited Create(AOwner);
  FCanvas:=TControlCanvas.Create; {ni pentros sur tiu chi kanvaso}
  TControlCanvas(FCanvas).Control:=Self;
  FCaption:='';
  Height := 21;
  ControlState:=ControlState + [csCustomPaint];
end; {TeoCheckBox.Create}

destructor TeoCheckBox.Destroy;
begin
  FCanvas.Free;
  inherited Destroy;
end; {TeoCheckBox.Destroy}

{Skribado de FCaption}
procedure TeoCheckBox.SetText (const Value: TCaption);
begin
    FCaption:=Value;
    {por Vindozo sciu pri akceliloj kaj ghuste pentru kadreton}
    inherited Caption:=SenChapel(Value);
    Paint;
end; {TeoCheckBox.SetText}

{Pentrado de kontroluja fenestro}
procedure TeoCheckBox.PaintWindow (DC: HDC);
begin
  FCanvas.Lock;
  try
    FCanvas.Handle:=DC;
    try
      inherited PaintWindow(DC);
      TControlCanvas(FCanvas).UpdateTextFlags;
      Paint;    {nepre necesas repentri, alie Vindozo vishos nian tekston}
    finally
      FCanvas.Handle:=0;
    end;
  finally
    FCanvas.Unlock;
  end;
end; {TeoCheckBox.PaintWindow}

{Pentrado de la markujo}
procedure TeoCheckBox.Paint;
begin
    if Parent=nil then exit;    {alie okazos krasho dum dizajn-tempo}
    FCanvas.Font:=Font;
    FCanvas.Brush.Color:=Color;
    eoPaint(FCanvas,FCaption,GetClientRect,False,False,18);
end; {TeoCheckBox.Paint}

{Kaptu eventon, kiam musmontrilo eniras sur la markujon}
procedure TeoCheckBox.CMMouseEnter (var Message: TMessage);
begin
  inherited;
  if Assigned(FOnMouseEnter) then FOnMouseEnter(Self);
end; {TeoCheckBox.CMMouseEnter}

{Kaptu eventon, kiam musmontrilo foriras el sur la markujo}
procedure TeoCheckBox.CMMouseLeave (var Message: TMessage);
begin
  inherited;
  if Assigned(FOnMouseLeave) then FOnMouseLeave(Self);
end; {TeoCheckBox.CMMouseLeave}


{--- TeoRadioButton ---}

constructor TeoRadioButton.Create (AOwner: TComponent);
begin
  inherited Create(AOwner);
  FCanvas:=TControlCanvas.Create; {ni pentros sur tiu chi kanvaso}
  TControlCanvas(FCanvas).Control:=Self;
  FCaption:='';
  Height := 21;
  ControlState:=ControlState + [csCustomPaint];
end; {TeoRadioButton.Create}

destructor TeoRadioButton.Destroy;
begin
  FCanvas.Free;
  inherited Destroy;
end; {TeoRadioButton.Destroy}

{Skribado de FCaption}
procedure TeoRadioButton.SetText (const Value: TCaption);
begin
    FCaption:=Value;
    {por Vindozo sciu pri akceliloj kaj ghuste pentru kadreton}
    inherited Caption:=SenChapel(Value);
    Paint;
end; {TeoRadioButton.SetText}

{Pentrado de radiobutona fenestro}
procedure TeoRadioButton.PaintWindow (DC: HDC);
begin
  FCanvas.Lock;
  try
    FCanvas.Handle:=DC;
    try
      inherited PaintWindow(DC);
      TControlCanvas(FCanvas).UpdateTextFlags;
      Paint;    {nepre necesas repentri, alie Vindozo vishos nian tekston}
    finally
      FCanvas.Handle:=0;
    end;
  finally
    FCanvas.Unlock;
  end;
end; {TeoRadioButton.PaintWindow}

{Pentrado de radiobutono}
procedure TeoRadioButton.Paint;
begin
    if Parent=nil then exit;    {alie okazos krasho dum dizajn-tempo}
    FCanvas.Font:=Font;
    FCanvas.Brush.Color:=Color;
    eoPaint(FCanvas,FCaption,GetClientRect,False,False,18);
end; {TeoRadioButton.Paint}

{Kaptu eventon, kiam musmontrilo eniras sur la radiobutonon}
procedure TeoRadioButton.CMMouseEnter (var Message: TMessage);
begin
  inherited;
  if Assigned(FOnMouseEnter) then FOnMouseEnter(Self);
end; {TeoRadioButton.CMMouseEnter}

{Kaptu eventon, kiam musmontrilo foriras el sur la radiobutonon}
procedure TeoRadioButton.CMMouseLeave (var Message: TMessage);
begin
  inherited;
  if Assigned(FOnMouseLeave) then FOnMouseLeave(Self);
end; {TeoRadioButton.CMMouseLeave}

end.

